--- /dev/null
+++ b/zipl/boot/kdump3.c
@@ -0,0 +1,108 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Stand-alone kdump support (stage 3)
+ *
+ * Copyright IBM Corp. 2013
+ */
+
+#include "sclp_stage3.h"
+#include "stage3.h"
+#include "error.h"
+#include "kdump.h"
+#include "libc.h"
+
+static struct os_info **lc_os_info = (struct os_info **)&S390_lowcore.os_info;
+
+/*
+ * Copy memory from HSA and exit in case of an error
+ */
+static void copy_from_hsa(unsigned long dst, unsigned long src, int cnt)
+{
+	if (sclp_hsa_copy((void *) dst, 2 + src / PAGE_SIZE, cnt / PAGE_SIZE)) {
+		sclp_hsa_copy_exit();
+		kdump_failed(EHSA_COPY_FAILED);
+	}
+}
+
+/*
+ * Save lower memory to crash kernel memory and get crash base and size
+ */
+static void kdump_stage3_scsi(unsigned long *base, unsigned long *size)
+{
+	unsigned long os_info_addr, crash_base, crash_size, crash_end, hsa_page;
+	struct os_info *os_info;
+	unsigned long hsa_size;
+
+	hsa_page = get_zeroed_page();
+	sclp_hsa_copy_init((void *) hsa_page);
+	if (sclp_hsa_get_size(&hsa_size)) {
+		sclp_hsa_copy_exit();
+		kdump_failed(EHSA_COPY_FAILED);
+	}
+	/* Get OS info pointer from HSA lowcore */
+	copy_from_hsa(hsa_page, 0, PAGE_SIZE);
+	os_info_addr = *((unsigned long *) (hsa_page + __LC_OS_INFO));
+	/* If OS info is inside HSA, get it from there */
+	if (os_info_addr < hsa_size) {
+		copy_from_hsa(hsa_page, os_info_addr, PAGE_SIZE);
+		os_info = (void *) hsa_page;
+	} else {
+		os_info = (void *) os_info_addr;
+	}
+	os_info_check(os_info);
+	crash_base = os_info->crashkernel_addr;
+	crash_size = os_info->crashkernel_size;
+	crash_end = crash_base + crash_size;
+	/*
+	 * Copy [0, crash_size] to [crash_base, crash_base + crash_size] and
+	 * restore 1:1 memory from HSA
+	 */
+
+	/* copy [0, MIN(crash_size, hsa_size)] to [crash base, ...] from HSA */
+	copy_from_hsa(crash_base, 0, MIN(crash_size, hsa_size));
+	if (crash_size > hsa_size) {
+		/* Copy rest of crashkernel from real memory */
+		memcpy((void *) crash_base + hsa_size, (void *) hsa_size,
+		       crash_size - hsa_size);
+	} else {
+		/* Restore real memory above crash_size 1:1 from HSA */
+		copy_from_hsa(crash_size, crash_size,
+			      MIN(hsa_size, crash_base) - crash_size);
+	}
+	if (crash_end < hsa_size) {
+		/* Restore memory above crash end 1:1 from HSA */
+		copy_from_hsa(crash_end, crash_end, hsa_size -  crash_end);
+	}
+	sclp_hsa_copy_exit();
+	*base = __pa(crash_base);
+	*size = crash_size;
+}
+
+/*
+ * Get crash base and size from (stage 2 relocated) OS info lowcore pointer
+ */
+static void kdump_stage3_dasd(unsigned long *base, unsigned long *size)
+{
+	*base = (*lc_os_info)->crashkernel_addr;
+	*size = (*lc_os_info)->crashkernel_size;
+}
+
+/*
+ * Stage 3 kdump code
+ */
+void kdump_stage3(void)
+{
+	unsigned long crash_base, crash_size;
+
+	if (!(stage3_flags & STAGE3_FLAG_KDUMP))
+		return;
+	if (!(stage3_flags & STAGE3_FLAG_SCSI))
+		kdump_stage3_dasd(&crash_base, &crash_size);
+	else
+		kdump_stage3_scsi(&crash_base, &crash_size);
+
+	/* Register oldmem in kernel parameter area */
+	*((unsigned long *) OLDMEM_BASE) = crash_base;
+	*((unsigned long *) OLDMEM_SIZE) = crash_size;
+}
--- /dev/null
+++ b/zipl/boot/libc.c
@@ -0,0 +1,380 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Mini libc implementation
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ *            Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include <stdarg.h>
+#include "libc.h"
+#include "sclp.h"
+#include "error.h"
+
+extern char __heap_start[];
+extern char __heap_stop[];
+extern char __bss_start[];
+extern char __bss_stop[];
+extern char __ex_table_start[];
+extern char __ex_table_stop[];
+
+struct ex_table_entry {
+	int fault;
+	int target;
+};
+
+#define MEM_ALLOC_START	((unsigned long) __heap_start)
+#define MEM_ALLOC_CNT 4
+
+static uint8_t mem_page_alloc_vec[MEM_ALLOC_CNT];
+
+/*
+ * Initialize memory with value
+ */
+void *memset(void *s, int c, unsigned long n)
+{
+	char *xs;
+
+	xs = s;
+	while (n--)
+		*xs++ = c;
+	return s;
+}
+
+/*
+ * Copy memory
+ */
+void *memcpy(void *dest, const void *src, unsigned long n)
+{
+	const char *s = src;
+	char *d = dest;
+
+	while (n--)
+		*d++ = *s++;
+	return dest;
+}
+
+/*
+ * Copy string
+ */
+char *strcpy(char *dest, const char *src)
+{
+	const char *s = src;
+	char *d = dest;
+
+	while (*s)
+		*d++ = *s++;
+	*d = 0;
+	return dest;
+}
+
+/*
+ * Return string length
+ */
+int strlen(const char *s)
+{
+	int len = 0;
+
+	while (*s++)
+		len++;
+	return len;
+}
+
+/*
+ * Concatenate two strings
+ */
+char *strcat(char *dest, const char *src)
+{
+	strcpy(dest + strlen(dest), src);
+	return dest;
+}
+
+/*
+ * Compare two strings
+ */
+int strncmp(const char *s1, const char *s2, unsigned long count)
+{
+	while (count--)
+		if (*s1++ != *s2++)
+			return *(unsigned char *)(s1 - 1) -
+				*(unsigned char *)(s2 - 1);
+	return 0;
+}
+
+/*
+ * Convert number to string
+ *
+ * Parameters:
+ *
+ * - buf:   Output buffer
+ * - base:  Base used for formatting (e.g. 10 or 16)
+ * - val:   Number to format
+ * - zero:  If > 0, fill with leading zeros, otherwise use blanks
+ * - count: Minimum number of characters used for output string
+ */
+static int num_to_str(char *buf, int base, unsigned long val, int zero,
+		      unsigned long count)
+{
+	static const char conv_vec[] = {'0', '1', '2', '3', '4', '5', '6', '7',
+					'8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
+	unsigned long num = 0, val_work = val, in_number = 1;
+	int i;
+
+	/* Count number of characters needed for number */
+	do {
+		num++;
+		val_work /= base;
+	} while (val_work);
+	/* Real character number overwrites count */
+	if (count < num)
+		count = num;
+	/* Format number */
+	for (i = count - 1; i >= 0; i--) {
+		if (in_number) {
+			buf[i] = conv_vec[val % base];
+			val /= base;
+			in_number = val ? 1 : 0;
+		} else {
+			buf[i] = zero ? '0' : ' ';
+		}
+	}
+	buf[count] = 0;
+	return count;
+}
+
+/*
+ * Convert string to string with indentation
+ */
+static int str_to_str(char *buf, const char *str, unsigned long count)
+{
+	unsigned long size;
+
+	size = strlen(str);
+	if (count < size)
+		count = size;
+	else
+		memset(buf, ' ', count - size);
+	strcpy(buf + (count - size), str);
+	return count;
+}
+
+/*
+ * Convert string to number with given base
+ */
+unsigned long strtoul(const char *nptr, char **endptr, int base)
+{
+	unsigned long val = 0;
+
+	while (isdigit(*nptr)) {
+		if (val != 0)
+			val *= base;
+		val += *nptr - '0';
+		nptr++;
+	}
+	if (endptr)
+		*endptr = (char *) nptr;
+	return val;
+}
+
+/*
+ * Convert ebcdic string to number with given base
+ */
+unsigned long ebcstrtoul(char *nptr, char **endptr, int base)
+{
+	unsigned long val = 0;
+
+	while (ebc_isdigit(*nptr)) {
+		if (val != 0)
+			val *= base;
+		val += *nptr - 0xf0;
+		nptr++;
+	}
+	if (endptr)
+		*endptr = (char *) nptr;
+	return val;
+}
+
+/*
+ * Convert string to number with given base
+ */
+static int sprintf_fmt(char type, char *buf, unsigned long val, int zero,
+		       int count)
+{
+	switch (type) {
+	case 's':
+		return str_to_str(buf, (const char *) val, count);
+	case 'x':
+		return num_to_str(buf, 16, val, zero, count);
+	case 'u':
+		return num_to_str(buf, 10, val, zero, count);
+	default:
+		libc_stop(EINTERNAL);
+	}
+	return 0;
+}
+
+/*
+ * Print formated string (va version)
+ */
+static void vsprintf(char *str, const char *fmt, va_list va)
+{
+	unsigned long val, zero, count;
+	char *fmt_next;
+
+	do {
+		if (*fmt == '%') {
+			fmt++;
+			if (*fmt == '0') {
+				zero = 1;
+				fmt++;
+			} else {
+				zero = 0;
+			}
+			/* No number found by strtoul: count=0 fmt_next=fmt */
+			count = strtoul(fmt, &fmt_next, 10);
+			fmt = fmt_next;
+			if (*fmt == 'l')
+				fmt++;
+			val = va_arg(va, unsigned long);
+			str += sprintf_fmt(*fmt, str, val, zero, count);
+			fmt++;
+		} else {
+			*str++ = *fmt++;
+		}
+	} while (*fmt);
+	*str = 0;
+}
+
+/*
+ * Write formated string to string
+ */
+void sprintf(char *str, const char *fmt, ...)
+{
+	va_list va;
+
+	va_start(va, fmt);
+	vsprintf(str, fmt, va);
+	va_end(va);
+}
+
+/*
+ * Print formated string
+ */
+void printf(const char *fmt, ...)
+{
+	char buf[81];
+	va_list va;
+
+	va_start(va, fmt);
+	vsprintf(buf, fmt, va);
+	sclp_print(buf);
+	va_end(va);
+}
+
+/*
+ * Allocate one zero page
+ */
+unsigned long get_zeroed_page(void)
+{
+	unsigned long addr;
+	int i;
+
+	for (i = 0; i < MEM_ALLOC_CNT; i++) {
+		if (mem_page_alloc_vec[i] != 0)
+			continue;
+		addr = MEM_ALLOC_START + i * PAGE_SIZE;
+		memset((void *) addr, 0, PAGE_SIZE);
+		mem_page_alloc_vec[i] = 1;
+		return addr;
+	}
+	libc_stop(EINTERNAL);
+}
+
+/*
+ * Free page
+ */
+void free_page(unsigned long addr)
+{
+	mem_page_alloc_vec[(addr - MEM_ALLOC_START) / PAGE_SIZE] = 0;
+}
+
+/*
+ * Program check handler
+ */
+void pgm_check_handler_fn(void)
+{
+	struct ex_table_entry *ex_table = (void *) __ex_table_start;
+	struct psw_t *psw_old = &S390_lowcore.program_old_psw;
+	int i, ex_table_cnt;
+	unsigned long fault, target;
+
+	ex_table_cnt = (__ex_table_stop - __ex_table_start)
+		/ sizeof(struct ex_table_entry);
+
+	for (i = 0; i < ex_table_cnt; i++) {
+		fault = __pa(&ex_table[i]) + ex_table[i].fault;
+		if (fault == psw_old->addr) {
+			target = __pa(&ex_table[i]) + ex_table[i].target;
+			psw_old->addr = target;
+			return;
+		}
+	}
+	libc_stop(psw_old->addr);
+}
+
+__attribute__ ((noinline)) void load_wait_psw(uint64_t psw_mask, struct psw_t *psw)
+{
+	struct psw_t wait_psw = { .mask = psw_mask, .addr = 0 };
+	struct psw_t old_psw, *wait_psw_ptr = &wait_psw;
+	unsigned long addr;
+
+	old_psw = *psw;
+	psw->mask = 0x0000000180000000ULL;
+	asm volatile(
+		"	larl	%[addr],.Lwait\n"
+		"       stg     %[addr],8(%[wait_psw_ptr])\n"
+		"       stg     %[addr],8(%[psw])\n"
+		"       lpswe	%[wait_psw]\n"
+		".Lwait:	\n"
+		: [addr] "=&d" (addr)
+		: [wait_psw] "Q" (wait_psw), [wait_psw_ptr] "a" (wait_psw_ptr),
+		  [psw] "a" (psw)
+		: "cc", "memory");
+	*psw = old_psw;
+}
+
+/*
+ * The libc startup function
+ */
+void initialize(void)
+{
+	struct psw_t *psw_pgm = &S390_lowcore.program_new_psw;
+
+	/* Setup program check handler */
+	psw_pgm->mask = 0x0000000180000000ULL;
+	psw_pgm->addr = (unsigned long) pgm_check_handler;
+
+	/* Clear bss section */
+	memset(__bss_start, 0, __bss_stop - __bss_start);
+	start();
+}
+
+/*
+ * Load disabled wait PSW with reason code in address field
+ */
+void libc_stop(unsigned long reason)
+{
+	struct psw_t psw;
+
+	psw.mask = 0x0002000080000000ULL;
+	psw.addr = reason;
+
+	asm volatile(
+		"	lpswe	 %[psw]\n"
+		: : [psw] "Q" (psw) : "cc"
+		);
+
+	while(1);
+}
--- /dev/null
+++ b/zipl/boot/libc.h
@@ -0,0 +1,103 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Mini libc implementation
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ *            Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+#ifndef LIBC_H
+#define LIBC_H
+
+#define NULL ((void *) 0)
+
+#define EPERM		 1	/* Operation not permitted */
+#define ENOENT		 2	/* No such file or directory */
+#define ESRCH		 3	/* No such process */
+#define EINTR		 4	/* Interrupted system call */
+#define EIO		 5	/* I/O error */
+#define ENXIO		 6	/* No such device or address */
+#define E2BIG		 7	/* Argument list too long */
+#define ENOEXEC		 8	/* Exec format error */
+#define EBADF		 9	/* Bad file number */
+#define ECHILD		10	/* No child processes */
+#define EAGAIN		11	/* Try again */
+#define ENOMEM		12	/* Out of memory */
+#define EACCES		13	/* Permission denied */
+#define EFAULT		14	/* Bad address */
+#define ENOTBLK		15	/* Block device required */
+#define EBUSY		16	/* Device or resource busy */
+#define EEXIST		17	/* File exists */
+#define EXDEV		18	/* Cross-device link */
+#define ENODEV		19	/* No such device */
+#define ENOTDIR		20	/* Not a directory */
+#define EISDIR		21	/* Is a directory */
+#define EINVAL		22	/* Invalid argument */
+#define ENFILE		23	/* File table overflow */
+#define EMFILE		24	/* Too many open files */
+#define ENOTTY		25	/* Not a typewriter */
+
+#define MIB	(1024ULL * 1024)
+
+typedef unsigned long long uint64_t;
+typedef unsigned int uint32_t;
+typedef unsigned short uint16_t;
+typedef unsigned char uint8_t;
+
+#include "s390.h"
+
+void printf(const char *, ...);
+void sprintf(char *, const char *, ...);
+void *memcpy(void *, const void *, unsigned long);
+void *memset(void *, int c, unsigned long);
+char *strcat(char *, const char *);
+int strncmp(const char *, const char *, unsigned long);
+unsigned long strtoul(const char *, char **, int);
+unsigned long ebcstrtoul(char *, char **, int);
+int strlen(const char *);
+char *strcpy(char *, const char *);
+unsigned long get_zeroed_page(void);
+void free_page(unsigned long);
+void initialize(void);
+void libc_stop(unsigned long) __attribute__((noreturn));
+void start(void);
+void pgm_check_handler(void);
+void load_wait_psw(uint64_t, struct psw_t *);
+void pgm_check_handler_fn(void);
+
+static inline int isdigit(int c)
+{
+	return (c >= '0') && (c <= '9');
+}
+
+static inline int isspace(char c)
+{
+	return (c == 32) || (c >= 9 && c <= 13);
+}
+
+static inline int ebc_isspace(char c)
+{
+	return (c == 0x40) || (c == 0x05) || (c == 0x15) || (c == 0x25) ||
+		(c == 0x0b) || (c == 0x0c) || (c == 0x0d);
+}
+
+static inline int ebc_isdigit(char c)
+{
+	return (c >= 0xf0) && (c <= 0xf9);
+}
+
+static inline int ebc_isupper(char c)
+{
+	return (c >= 0xC1 && c <= 0xC9) || (c >= 0xD1 && c <= 0xD9) ||
+		(c >= 0xE2 && c <= 0xE9);
+}
+
+static inline  char ebc_tolower(char c)
+{
+	if (ebc_isupper(c))
+		c -= 0x40;
+	return c;
+}
+
+#endif /* LIBC_H */
--- /dev/null
+++ b/zipl/boot/menu.c
@@ -0,0 +1,194 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Bootmenu Subroutines
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "sclp.h"
+#include "menu.h"
+#include "libc.h"
+
+static const char *msg_econfig = "Error: undefined configuration\n";
+
+static void menu_prompt(int timeout)
+{
+	if (timeout)
+		printf("Please choose (default will boot in %u seconds):",
+		       timeout);
+	else
+		printf("Please choose:");
+}
+
+static int menu_read(void)
+{
+	char *temp_area =  (char *)get_zeroed_page();
+	uint16_t *configs = __stage2_params.config;
+	int timeout, rc, i, count = 0;
+	char *endptr;
+	int value;
+
+	timeout = __stage2_params.timeout;
+
+	while (1) {
+		/* print prompt */
+		menu_prompt(timeout);
+
+		/* wait for input or timeout */
+		while (count == 0) {
+			rc = sclp_read(timeout, temp_area, &count);
+			if (rc != 0) {
+				/* timeout or error during read, boot default */
+				value = 0;
+				goto out_free_page;
+			}
+			/* disable timeout in case of retry */
+			timeout = 0;
+		}
+
+		if (count > LINE_LENGTH)
+			count = LINE_LENGTH;
+
+		/* input under zVM needs to be converted to lower case */
+		if (is_zvm())
+			for (i = 0; i < count; i++)
+				temp_area[i] = ebc_tolower(temp_area[i]);
+		value = ebcstrtoul((char *)temp_area, &endptr, 10);
+
+		if ((endptr != temp_area) && (value < BOOT_MENU_ENTRIES - 1) &&
+		    (configs[value] != 0)) {
+			/* valid config found - finish */
+			break;
+		} else {
+			/* no valid config retry */
+			printf(msg_econfig);
+			count = 0;
+		}
+	}
+
+	if (temp_area + count > endptr)
+		memcpy((void *)COMMAND_LINE_EXTRA, endptr,
+		       (temp_area + count - endptr));
+out_free_page:
+	free_page((unsigned long) temp_area);
+	return value;
+}
+
+static int menu_list(void)
+{
+	uint16_t *configs = __stage2_params.config;
+	char *name;
+	int i;
+
+	for (i = 0; i < BOOT_MENU_ENTRIES; i++) {
+		if (configs[i] == 0)
+			continue;
+		name = configs[i] + ((void *)&__stage2_params);
+		printf("%s\n", name);
+		if (i == 0)
+			printf("\n");
+	}
+
+	return 0;
+}
+
+/*
+ * Interpret loadparm
+ *
+ * Parameter
+ *     value - to store configuration number
+ *
+ * Return
+ *     0 - found number to boot, stored in value
+ *     1 - print prompt
+ *     2 - nothing found
+ */
+static int menu_param(unsigned long *value)
+{
+	char loadparm[PARAM_SIZE];
+	char *endptr;
+	int i;
+
+	if (!sclp_param(loadparm))
+		*value = ebcstrtoul(loadparm, &endptr, 10);
+
+	/* got number, done */
+	if (endptr != loadparm)
+		return NUMBER_FOUND;
+
+	/* no number, check for keyword */
+	i = 0;
+	/* skip leading whitespaces */
+	while (ebc_isspace(loadparm[i]) && (i < PARAM_SIZE))
+		i++;
+
+	if (!strncmp(&loadparm[i], "PROMPT", 6)) {
+		*value = 0;
+		return PRINT_PROMPT;
+	}
+
+	return NOTHING_FOUND;
+}
+
+int menu(void)
+{
+	uint16_t *configs = __stage2_params.config;
+	unsigned long value = 0;
+	char *cmd_line_extra;
+	char endstring[15];
+	int rc;
+
+	cmd_line_extra = (char *)COMMAND_LINE_EXTRA;
+	rc = sclp_setup(SCLP_INIT);
+	if (rc)
+		/* sclp setup failed boot default */
+		goto boot;
+
+	memset(cmd_line_extra, 0, COMMAND_LINE_SIZE);
+	rc = menu_param(&value);
+	if (rc == 0) {
+		/* got number from loadparm, boot it */
+		goto boot;
+	} else if (rc == 1 && value == 0) {
+		/* keyword "prompt", show menu */
+	} else if (__stage2_params.flag == 0) {
+		/* menu disabled, boot default */
+		value = 0;
+		goto boot;
+	}
+
+	/* print banner */
+	printf("%s\n", ((void *)&__stage2_params) + __stage2_params.banner);
+
+	/* print config list */
+	menu_list();
+
+	if (is_zvm())
+		printf("Note: VM users please use '#cp vi vmsg <input>'\n");
+
+	value = menu_read();
+
+	/* sanity - value too big */
+	if (value > BOOT_MENU_ENTRIES)
+		panic(EINTERNAL, "%s", msg_econfig);
+
+boot:
+	/* sanity - config entry not valid */
+	if (configs[value] == 0)
+		panic(EINTERNAL, "%s", msg_econfig);
+
+	printf("Booting %s\n",
+	       (char *)(configs[value] +
+			(void *)&__stage2_params + TEXT_OFFSET));
+
+	/* append 'BOOT_IMAGE=<num>' to parmline */
+	sprintf(endstring, " BOOT_IMAGE=%u", value);
+	if ((strlen(cmd_line_extra) + strlen(endstring)) < COMMAND_LINE_SIZE)
+		strcat(cmd_line_extra, endstring);
+
+	sclp_setup(SCLP_DISABLE);
+
+	return value;
+}
--- /dev/null
+++ b/zipl/boot/menu.h
@@ -0,0 +1,41 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Bootmenu Subroutines
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#ifndef MENU_H
+#define MENU_H
+
+#include "stage2.h"
+
+/* address of extra command line */
+#define COMMAND_LINE_EXTRA	        (0xA000-0x400)
+
+/* max command line length */
+#define COMMAND_LINE_SIZE	        896
+#define BOOT_MENU_ENTRIES		63
+#define LINE_LENGTH                     80
+#define PARAM_SIZE                      8
+#define TEXT_OFFSET                     4
+
+#define NUMBER_FOUND                    0
+#define PRINT_PROMPT                    1
+#define NOTHING_FOUND                   2
+
+struct boot_stage2_params {
+	uint16_t flag;
+	uint16_t timeout;
+	uint16_t banner;
+	uint16_t config[BOOT_MENU_ENTRIES];
+	uint64_t config_kdump;
+} __packed;
+
+extern struct boot_stage2_params __stage2_params;
+
+int menu();
+
+#endif /* MENU_H */
--- /dev/null
+++ b/zipl/boot/s390.h
@@ -0,0 +1,374 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * System z specific functions
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ *            Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+#ifndef S390_H
+#define S390_H
+
+#include "libc.h"
+#include "../../include/zt_common.h"
+
+#define __packed __attribute__((packed))
+#define __aligned(x) __attribute__((aligned(x)))
+#define __pa32(x) ((uint32_t)(unsigned long)(x))
+#define __pa(x) ((unsigned long)(x))
+#define MIN(x, y) ((x) < (y) ? (x) : (y))
+#define barrier() __asm__ __volatile__("": : :"memory")
+
+/*
+ * Helper macro for exception table entries
+ */
+#define EX_TABLE(_fault, _target)	\
+	".section .ex_table,\"a\"\n"	\
+	".align	4\n"			\
+	".long	(" #_fault ") - .\n"	\
+	".long	(" #_target ") - .\n"	\
+	".previous\n"
+
+struct psw_t {
+	uint64_t mask;
+	uint64_t addr;
+} __aligned(8);
+
+struct _lowcore {
+	uint8_t	pad_0x0000[0x0014-0x0000];	/* 0x0000 */
+	uint32_t	ipl_parmblock_ptr;		/* 0x0014 */
+	uint8_t	pad_0x0018[0x0080-0x0018];	/* 0x0018 */
+	uint32_t	ext_params;			/* 0x0080 */
+	uint16_t	ext_cpu_addr;			/* 0x0084 */
+	uint16_t	ext_int_code;			/* 0x0086 */
+	uint16_t	svc_ilc;			/* 0x0088 */
+	uint16_t	svc_code;			/* 0x008a */
+	uint16_t	pgm_ilc;			/* 0x008c */
+	uint16_t	pgm_code;			/* 0x008e */
+	uint32_t	data_exc_code;			/* 0x0090 */
+	uint16_t	mon_class_num;			/* 0x0094 */
+	uint16_t	per_perc_atmid;			/* 0x0096 */
+	uint64_t	per_address;			/* 0x0098 */
+	uint8_t	exc_access_id;			/* 0x00a0 */
+	uint8_t	per_access_id;			/* 0x00a1 */
+	uint8_t	op_access_id;			/* 0x00a2 */
+	uint8_t	ar_access_id;			/* 0x00a3 */
+	uint8_t	pad_0x00a4[0x00a8-0x00a4];	/* 0x00a4 */
+	uint64_t	trans_exc_code;			/* 0x00a8 */
+	uint64_t	monitor_code;			/* 0x00b0 */
+	uint16_t	subchannel_id;			/* 0x00b8 */
+	uint16_t	subchannel_nr;			/* 0x00ba */
+	uint32_t	io_int_parm;			/* 0x00bc */
+	uint32_t	io_int_word;			/* 0x00c0 */
+	uint8_t	pad_0x00c4[0x00c8-0x00c4];	/* 0x00c4 */
+	uint32_t	stfl_fac_list;			/* 0x00c8 */
+	uint8_t	pad_0x00cc[0x00e8-0x00cc];	/* 0x00cc */
+	uint32_t	mcck_interruption_code[2];	/* 0x00e8 */
+	uint8_t	pad_0x00f0[0x00f4-0x00f0];	/* 0x00f0 */
+	uint32_t	external_damage_code;		/* 0x00f4 */
+	uint64_t	failing_storage_address;	/* 0x00f8 */
+	uint8_t	pad_0x0100[0x0110-0x0100];	/* 0x0100 */
+	uint64_t	breaking_event_addr;		/* 0x0110 */
+	uint8_t	pad_0x0118[0x0120-0x0118];	/* 0x0118 */
+	struct psw_t	restart_old_psw;		/* 0x0120 */
+	struct psw_t	external_old_psw;		/* 0x0130 */
+	struct psw_t	svc_old_psw;			/* 0x0140 */
+	struct psw_t	program_old_psw;		/* 0x0150 */
+	struct psw_t	mcck_old_psw;			/* 0x0160 */
+	struct psw_t	io_old_psw;			/* 0x0170 */
+	uint8_t	pad_0x0180[0x01a0-0x0180];	/* 0x0180 */
+	struct psw_t	restart_psw;			/* 0x01a0 */
+	struct psw_t	external_new_psw;		/* 0x01b0 */
+	struct psw_t	svc_new_psw;			/* 0x01c0 */
+	struct psw_t	program_new_psw;		/* 0x01d0 */
+	struct psw_t	mcck_new_psw;			/* 0x01e0 */
+	struct psw_t	io_new_psw;			/* 0x01f0 */
+
+	/* Save areas. */
+	uint64_t	save_area_sync[8];		/* 0x0200 */
+	uint64_t	save_area_async[8];		/* 0x0240 */
+	uint64_t	save_area_restart[1];		/* 0x0280 */
+	uint8_t	pad_0x0288[0x0290-0x0288];	/* 0x0288 */
+
+	/* Return psws. */
+	struct psw_t	return_psw;			/* 0x0290 */
+	struct psw_t	return_mcck_psw;		/* 0x02a0 */
+
+	/* CPU accounting and timing values. */
+	uint64_t	sync_enter_timer;		/* 0x02b0 */
+	uint64_t	async_enter_timer;		/* 0x02b8 */
+	uint64_t	mcck_enter_timer;		/* 0x02c0 */
+	uint64_t	exit_timer;			/* 0x02c8 */
+	uint64_t	user_timer;			/* 0x02d0 */
+	uint64_t	system_timer;			/* 0x02d8 */
+	uint64_t	steal_timer;			/* 0x02e0 */
+	uint64_t	last_update_timer;		/* 0x02e8 */
+	uint64_t	last_update_clock;		/* 0x02f0 */
+	uint64_t	int_clock;			/* 0x02f8 */
+	uint64_t	mcck_clock;			/* 0x0300 */
+	uint64_t	clock_comparator;		/* 0x0308 */
+
+	/* Current process. */
+	uint64_t	current_task;			/* 0x0310 */
+	uint64_t	thread_info;			/* 0x0318 */
+	uint64_t	kernel_stack;			/* 0x0320 */
+
+	/* Interrupt, panic and restart stack. */
+	uint64_t	async_stack;			/* 0x0328 */
+	uint64_t	panic_stack;			/* 0x0330 */
+	uint64_t	restart_stack;			/* 0x0338 */
+
+	/* Restart function and parameter. */
+	uint64_t	restart_fn;			/* 0x0340 */
+	uint64_t	restart_data;			/* 0x0348 */
+	uint64_t	restart_source;			/* 0x0350 */
+
+	/* Address space pointer. */
+	uint64_t	kernel_asce;			/* 0x0358 */
+	uint64_t	user_asce;			/* 0x0360 */
+	uint64_t	current_pid;			/* 0x0368 */
+
+	/* SMP info area */
+	uint32_t	cpu_nr;				/* 0x0370 */
+	uint32_t	softirq_pending;		/* 0x0374 */
+	uint64_t	percpu_offset;			/* 0x0378 */
+	uint64_t	vdso_per_cpu_data;		/* 0x0380 */
+	uint64_t	machine_flags;			/* 0x0388 */
+	uint64_t	ftrace_func;			/* 0x0390 */
+	uint64_t	gmap;				/* 0x0398 */
+	uint8_t	pad_0x03a0[0x0400-0x03a0];	/* 0x03a0 */
+
+	/* Interrupt response block. */
+	uint8_t	irb[64];			/* 0x0400 */
+
+	/* Per cpu primary space access list */
+	uint32_t	paste[16];			/* 0x0440 */
+
+	uint8_t	pad_0x0480[0x0e00-0x0480];	/* 0x0480 */
+
+	/*
+	 * 0xe00 contains the address of the IPL Parameter Information
+	 * block. Dump tools need IPIB for IPL after dump.
+	 * Note: do not change the position of any fields in 0x0e00-0x0f00
+	 */
+	uint64_t	ipib;				/* 0x0e00 */
+	uint32_t	ipib_checksum;			/* 0x0e08 */
+	uint64_t	vmcore_info;			/* 0x0e0c */
+	uint8_t	pad_0x0e14[0x0e18-0x0e14];	/* 0x0e14 */
+	uint64_t	os_info;			/* 0x0e18 */
+	uint8_t	pad_0x0e20[0x0f00-0x0e20];	/* 0x0e20 */
+
+	/* Extended facility list */
+	uint64_t	stfle_fac_list[32];		/* 0x0f00 */
+	uint8_t	pad_0x1000[0x11b8-0x1000];	/* 0x1000 */
+
+	/* 64 bit extparam used for pfault/diag 250: defined by architecture */
+	uint64_t	ext_params2;			/* 0x11B8 */
+	uint8_t	pad_0x11c0[0x1200-0x11C0];	/* 0x11C0 */
+
+	/* CPU register save area: defined by architecture */
+	uint64_t	floating_pt_save_area[16];	/* 0x1200 */
+	uint64_t	gpregs_save_area[16];		/* 0x1280 */
+	struct psw_t	psw_save_area;			/* 0x1300 */
+	uint8_t	pad_0x1310[0x1318-0x1310];	/* 0x1310 */
+	uint32_t	prefixreg_save_area;		/* 0x1318 */
+	uint32_t	fpt_creg_save_area;		/* 0x131c */
+	uint8_t	pad_0x1320[0x1324-0x1320];	/* 0x1320 */
+	uint32_t	tod_progreg_save_area;		/* 0x1324 */
+	uint32_t	cpu_timer_save_area[2];		/* 0x1328 */
+	uint32_t	clock_comp_save_area[2];	/* 0x1330 */
+	uint8_t	pad_0x1338[0x1340-0x1338];	/* 0x1338 */
+	uint32_t	access_regs_save_area[16];	/* 0x1340 */
+	uint64_t	cregs_save_area[16];		/* 0x1380 */
+	uint8_t	pad_0x1400[0x1800-0x1400];	/* 0x1400 */
+
+	/* Transaction abort diagnostic block */
+	uint8_t	pgm_tdb[256];			/* 0x1800 */
+
+	/* align to the top of the prefix area */
+	uint8_t	pad_0x1900[0x2000-0x1900];	/* 0x1900 */
+} __packed;
+
+#define S390_lowcore (*((struct _lowcore *) 0))
+
+#define __LC_IPLDEV		0x0c6c
+#define __LC_OS_INFO		0x0e18
+
+#define PAGE_SIZE		4096
+
+void panic_notify(unsigned long reason);
+
+#define panic(reason, x...) \
+do { \
+	printf(x); \
+	panic_notify(reason); \
+	libc_stop(reason); \
+} while (0)
+
+#define CHUNK_READ_WRITE	0
+#define CHUNK_READ_ONLY		1
+
+static inline int tprot(unsigned long addr)
+{
+	int rc = -EFAULT;
+
+	asm volatile(
+		"       tprot   0(%1),0\n"
+		"0:     ipm     %0\n"
+		"       srl     %0,28\n"
+		"1:\n"
+		EX_TABLE(0b,1b)
+		: "+d" (rc) : "a" (addr) : "cc");
+	return rc;
+}
+
+static inline int page_is_valid(unsigned long addr)
+{
+	int rc;
+
+	rc = tprot(addr);
+	return (rc == CHUNK_READ_WRITE) || (rc == CHUNK_READ_ONLY);
+}
+
+static inline uint32_t csum_partial(const void *buf, int len, uint32_t sum)
+{
+	register unsigned long reg2 asm("2") = (unsigned long) buf;
+	register unsigned long reg3 asm("3") = (unsigned long) len;
+
+	asm volatile(
+		"0:     cksm    %0,%1\n"        /* do checksum on longs */
+		"       jo      0b\n"
+		: "+d" (sum), "+d" (reg2), "+d" (reg3) : : "cc", "memory");
+	return sum;
+}
+
+#define __ctl_store(array, low, high) ({		    \
+	typedef struct { char _[sizeof(array)]; } addrtype; \
+	asm volatile(					    \
+		"	stctg	%1,%2,%0\n"		    \
+		: "=Q" (*(addrtype *)(&array))		    \
+		: "i" (low), "i" (high));		    \
+})
+
+#define __ctl_load(array, low, high) ({			    \
+	typedef struct { char _[sizeof(array)]; } addrtype; \
+	asm volatile(					    \
+		"	lctlg	%1,%2,%0\n"			\
+		: : "Q" (*(addrtype *)(&array)),		\
+		  "i" (low), "i" (high));			\
+})
+
+/*
+ * DIAG 308 support
+ */
+enum diag308_subcode {
+	DIAG308_REL_HSA = 2,
+	DIAG308_IPL	= 3,
+	DIAG308_DUMP	= 4,
+	DIAG308_SET	= 5,
+	DIAG308_STORE	= 6,
+};
+
+static inline int diag308(unsigned long subcode, void *addr)
+{
+	register unsigned long _addr asm("0") = (unsigned long) addr;
+	register unsigned long _rc asm("1") = 0;
+
+	asm volatile(
+		"	diag	%0,%2,0x308\n"
+		"0:\n"
+		: "+d" (_addr), "+d" (_rc)
+		: "d" (subcode) : "cc", "memory");
+	return _rc;
+}
+
+/*
+ * Signal Processor
+ */
+#define SIGP_STOP_AND_STORE_STATUS	9
+
+#define SIGP_CC_ORDER_CODE_ACCEPTED	0
+#define SIGP_CC_BUSY			2
+
+static inline int sigp(uint16_t addr, uint8_t order, uint32_t parm,
+		       uint32_t *status)
+{
+	register unsigned int reg1 asm ("1") = parm;
+	int cc;
+
+	asm volatile(
+		"	sigp	%1,%2,0(%3)\n"
+		"	ipm	%0\n"
+		"	srl	%0,28\n"
+		: "=d" (cc), "+d" (reg1) : "d" (addr), "a" (order) : "cc");
+	if (status && cc == 1)
+		*status = reg1;
+	return cc;
+}
+
+/*
+ * Store CPU address
+ */
+static inline unsigned short stap(void)
+{
+	unsigned short cpu_address;
+
+	asm volatile("stap %0" : "=m" (cpu_address));
+	return cpu_address;
+}
+
+/*
+ * Program the clock comparator
+ */
+static inline void set_clock_comparator(uint64_t time)
+{
+	asm volatile("sckc %0" : : "Q" (time));
+}
+
+/*
+ * Program the CPU timer
+ */
+static inline void set_cpu_timer(uint64_t timer)
+{
+	asm volatile("spt %0" : : "Q" (timer));
+}
+
+/*
+ * Get current time (store clock)
+ */
+static inline unsigned long long get_tod_clock(void)
+{
+	unsigned long long clk;
+
+	asm volatile("stck %0" : "=Q" (clk) : : "cc");
+	return clk;
+}
+
+/*
+ * Get ID of current CPU
+ */
+struct cpuid {
+	unsigned int version:8;
+	unsigned int ident:24;
+	unsigned int machine:16;
+	unsigned int unused:16;
+} __packed __aligned(8);
+
+static inline void get_cpu_id(struct cpuid *ptr)
+{
+	asm volatile("stidp %0" : "=Q" (*ptr));
+}
+
+/*
+ * Check if we run under z/VM
+ */
+static inline int is_zvm(void)
+{
+	struct cpuid cpuid;
+
+	get_cpu_id(&cpuid);
+	return cpuid.version == 0xff;
+}
+
+#endif /* S390_H */
